
% IR_mes_12_2

%%
% TSP, Log-SS, Mn pCpX
%   TSP ́A؁A̕@
%   Log-SS ́A{̕@@x[XƂ

% gJbgp̍ʉ߃tB^
%        HPF70_30Hz_48k_80 Ă܂B 
% svȂRgAEg

% Ver. 1.0;   2013.8.28 TDU Y. Kaneda
% Ver. 2.0;   2014.02.16 TDU Y. Kaneda
%    IR_mes_12_2.m  ~Vtg֐ɓꂽA낢
%         IR_mes_12
%             2014. 8.21
%                Mn񐶐֐ sig_gen_MLS_01 ̃o[WAbv

% ̃vO͎QlvOł̂ŁApɂĂ
% ̐ӔCœmFsĂB
% s܂A
% kaneda@c.dendai.ac.jp
% ܂ł񂢂ƍKłB
%
% gpɓẮAp[^ݒ蕔̃p[^ƃXCb`ݒ肵ĂB
% 

%% ==============================
clear all; close all
set(0,'DefaultAxesFontSize',10,'DefaultTextFontSize',10,'DefaultUicontrolFontSize',12)

%% ===== p[^ݒ ===========
% --- M̃p[^ -----

fs = 48000;              % TvOg
NN = 2^16;               % M (1)A2ׂ̂A ĐԂ5
                         % 4,5ڂ̓[o͂ŔwiG̘^
                         % wiGXyNg\svȂsv
JJ = NN/2;               % IȐMiNNȉ̋j
AA = 0.5;                % UiMATLAB̏ꍇAP𒴂ȂƁj
                         % I[fBIC^tF[X̘cl
                         % 0.5 ʂK
                         % M n̏ꍇA֐ŋI0.4ȉƂ܂
                         
% --- XCb` ------------------------
signal_type = 1;         % M
                         %   1: TSP (up-TSP)
                         %   2: down-TSP
                         %   3: Log-SS
                         %   4: Mn
audio_in_out =1;         % I[fBIo͊֐ݒ
                         % @1: wavplay, wavrecord gꍇ
                         % @2: ASIO hCogꍇ
                         % @3: fFς݂̃CpXgf
                         % @4: ۑt@CpCpX̕\
kiridashi =0;            % CpX̐؂oݒ
                         % @0: ؂osȂ
                         % @1: ؂osig\SN䂪シj

%% ----- M쐬ilog-SS ܂ TSPj -----
switch signal_type
    case 1;    %  up-TSP
        [ss, ISS] = sig_gen_upTSP_03(NN, JJ, AA);
    case 2;    %  down-TSP
        [ss, ISS] = sig_gen_downTSP_03(NN, JJ, AA);
    case 3;    %  up_logTSP
        [ss, ISS] = sig_gen_Log_SS_03(NN, JJ, AA);
    case 4;    %  Mn
        [ss, ISS] = sig_gen_MLS_01(NN, AA);
        NN = NN-1;     % Mn̒ 2^M -1 Ȃ̂
    otherwise  % p[^G[
        disp('! signal_type p[^G['); return
end

% ----------------------------------------------
% ĐM̍
% ----------------------------------------------
% 3@AZ͍sȂ
% ŌɒGL^p̃[M2  S5Ԙ^
% DA  AD ̓ۏႳĂ邩ÁAAD^g`u̒xv
% łꍇ́AĐA^2ƂĂǂ
% gŎG덷\Ȃꍇ́AŌ̖Ԃ͕sv

out0 = [ss, ss, ss];

% --- [ɁAオA̕sA}XΑ
%       F2Đ̏ꍇ́A[݂̂Ƃ
nww = fs/1000*10;       % M[XΑ 10ms
ww = hanning(nww)';       % XΑ
out0(1:nww/2) = out0(1:nww/2) .* ww(1:nww/2);
out0(end-nww/2+1:end) = out0(end-nww/2+1:end) .* ww(end-nww/2+1:end);

% --- ĐMƕ\
out = [out0, zeros(1,2*NN)];

figure(1);subplot(2,1,1);plot( (1:length(out))/fs, out); xlim([0,inf]),
title('ĐMg`'); xlabel(' (s)')
hold on; for ii =1:4; plot([ii*NN,ii*NN]/fs,[-1,1],'g--'); end

figure(1);subplot(2,1,2); 
[bb2,ff,tt] = specgram(out,[],fs);
max2 = max(max(20*log10(abs(bb2))));
imagesc(tt,ff/1000,20*log10(abs(bb2)),[max2-100, max2]);axis xy;
title('ĐM̎ԁ|g');xlabel(' (s)'); ylabel('g (kHz)');

%% ----------------------------------------------
% ĐƓɘ^
% ----------------------------------------------
figure(101);
    text(0.05,0.8,' CpXs܂@ ','FontSize',16); drawnow;
    text(0.05,0.7,['@@@',num2str(ceil(length(out)/fs)),'bԁA𗧂ĂȂ悤ɂĂ'],'FontSize',16); drawnow;

% ȉ̇@|Ĉꂩs

switch audio_in_out

% --- @ wavplay  wavrecord g ------------------------
case 1
    wavplay(out,fs,'async');
    rec0 = wavrecord(length(out),fs);

% --- A ASIO g ------------------------
case 2
    rec0 = pa_wavplayrecord( out', [], fs, length(out), 1, 1, [], 'asio' ); 

% --- B fobOpV~[V ------------------------
case 3
    load imp_smpl;                    % V~[VpCpX̓ǂݍ
    rec0 = conv(out, imp_smpl);       % TSPMƃCpXƂ̏ݍ
    rec0 = rec0(1:length(out))' + randn(1,length(out))'*0.001;  % FGt
   
% --- C ۑt@C loard ------------------------   
case 4
    filename = uigetfile;
    load (filename)
    
otherwise
    disp('! audio_in_out p[^G['); return
end

figure(101); text(0.05,0.6,' CpXI@ ','FontSize',16); drawnow;

% --- ^f[^̐퐫`FbNiA0if[^j܂܂ĂȂHj
%     NbsOo

% [loss_yn, idx] = chk_dataloss_01(rec0, 10);
[loss_yn, idx] = chk_dataloss_01(rec0(fs*0.1+1:end), 50); % gpAD͐擪0f[^̂
if loss_yn==1; 
    disp(['^f[^ُ at ', num2str(idx+fs*0.1)])
    figure(81); plot((idx+fs*0.1-200:idx+fs*0.1+200),rec0(idx+fs*0.1-200:idx+fs*0.1+200)); 
    hold on; plot((idx+fs*0.1:idx+fs*0.1+50-1),rec0(idx+fs*0.1:idx+fs*0.1+50-1),'or')
    title('^ُF@^f[^ 0 AēĂ܂B')    
    return; 
end

% --- 摛
load 'HPF70_30Hz_48k_80';     % gJbgp̍ʉ߃tB^
                              % svȂRgAEg
                              % FIRŁAtB^ẂAϐuHPF70_48kv
rec0 = conv(rec0, HPF70_48k); % tB^
rec = rec0(length(HPF70_48k)/2+1:end-length(HPF70_48k)/2+1);
                              % Ԏ␳

%% ----------------------------------------------
% ^Mg`ƃXyNgO \ 
%    iߑEߏĐƓ̓{[AGA`덷Ȃǂ̃`FbNj
% ----------------------------------------------

figure(2)
plot( (1:length(rec))/fs ,rec)
title('^g`iNbsONĂȂH ǍDSN䂪mۂĂ邩Hj'); 
xlabel(' (s)'); ylabel('ΐU'); xlim([0,length(rec)/fs]);
hold on;for ii =1:4;plot([ii*NN,ii*NN]/fs,[-1,1],'g--');end

figure(3)
[bb2,ff,tt] = specgram(rec,[],fs);
max2 = max(max(20*log10(abs(bb2))));
imagesc(tt,ff/1000,20*log10(abs(bb2)),[max2-100, max2]);
colorbar;axis xy;grid on
title('^g`̃XyNgOigЂُ݂G`FbNj'); 
xlabel(' (s)'); ylabel('g (kHz)')
             % x (Ⴆ΁Aől -80dB x )̘c͖Ăǂƍl

figure(4)
[bb2,ff,tt] = specgram(rec(NN+1:2*NN),256,fs);
max2 = max(max(20*log10(abs(bb2))));
imagesc(tt,ff/1000,20*log10(abs(bb2)),[max2-100, max2]);
colorbar;axis xy;grid on
title('^g`̃XyNgOi1j'); xlabel(' (s)'); ylabel('g (kHz)')

%% ----------------------------------------------
% CpX Zo
% ----------------------------------------------

rec2 = cross_fade_01(rec, NN)';  % NXtF[h^2ڐ؂o

REC = fft(rec2);            % ^MDFT
IMP = REC.* ISS;            % ttB^ZČn̎g𓾂
                            % ̂܂܂łSN͈
                            % SN̗ǂg͈ȉɏqׂ
                            % uCpX̐؂ovKv
                            
imp = real(ifft(IMP));      % tDFTăCpX𓾂

% --- g`̉EVtgi\pj
nsft2 = round(NN/4);               % ₷邽ߔg`EɃVtg_iD݂Łj
imp2 = [imp(end-nsft2+1:end) imp(1:end-nsft2)]; 

figure(5)
plot( (-nsft2 : length(imp2)-nsft2-1 )/fs,imp2); grid on
title('CpX'); xlabel(' (s)'); ylabel('ΐU')
xlim([-inf,inf])

figure(6)
[bb2,ff,tt] = specgram(imp2,256,fs);     % XyNgO
max2 = max(max(20*log10(abs(bb2))));
imagesc(tt-nsft2/fs+128/fs, ff/1000,20*log10(abs(bb2)),[max2-100, max2]);
colorbar;axis xy;grid on
title('CpX̃XyNgOi1j'); xlabel(' (s)'); ylabel('g (kHz)')

% ʂ̋L^ --------------------
% save (['imp_IRmes_',datestr(now,30)], 'fs', 'NN', 'JJ', 'AA', 'rec0', 'ISS', 'nsft','imp','signal_type');
           % CpXi~VtgOjAсAp[^̋L^
           % ^̃f[^ rec0 L^i߁j
           % wavwrite 16rbgɗʎqďôŊ߂Ȃ
           % t@CɓL^^iD݂ŏCĂj

%% ----------------------------------------------------------------
% g
% ----------------------------------------------------------------

% CpX̐؂o ------------------------------
%@@@SNP

% () ؂o͑ш悲Ƃł͂ȂAS̈ꊇłB݂܂

if kiridashi == 1
    
    figure(31);
    text(0.05,0.6,' Command Window ɂ')
    text(0.05,0.5,'@@  CpX̐؂oԁi݂ԁj͂Ă')
    text(0.05,0.4,' ؂oԂ́ȂāA')
    text(0.05,0.3,'     Figure 5uCpXg`v̏cEg債ČČ߂Ă')
    text(0.05,0.2,'     Figure 6uCpX̃XyNgOvQlɂĂ')
    text(0.05,0.1,' if̏ꍇ́A擪0AI0.01 ƂĂj')
    
    ip1s = input('؂o擪 (s)H ');  % R}h擪̓
    ip9s = input('؂oI (s)H ');  % R}hI̓
    
    ip1 = nsft2 +ip1s *fs;                     % Ԃ_ɕϊ
    ip9 = nsft2 +ip9s *fs;                     % Ԃ_ɕϊ
    
    figure(5); hold on; 
    plot([ip1s,ip1s], [-max(abs(imp2)),max(abs(imp2))],'r');
    plot([ip9s,ip9s], [-max(abs(imp2)),max(abs(imp2))],'r');
    
    imp_cut = imp2(ip1:ip9);                  % ؂oCpX
    
    figure(32)
    plot( (ip1-nsft2:ip9-nsft2)/fs, imp_cut); grid on
    title('؂oCpX'); xlabel(' (s)'); ylabel('ΐU')
else
    ip1=1;ip9=NN;imp_cut=imp2;
end
    

% g̕\ ------------------------------

IMP = fft(imp_cut, NN);              % [tāANN_Ŏg߂
IMPS = abs(IMP) / max( abs(IMP) );   % őlŐKiől0dBƂĕ\邽߁BK{ł͂Ȃj
IMPSdB = 20*log10(IMPS);             % Bl߂

figure(7)
% plot( (0:NN/2)*(fs/NN), IMPSdB(1:NN/2+1 )); grid on;  % jAg plot
semilogx( (0:round(NN/2))*(fs/NN), IMPSdB(1:round(NN/2)+1 )); grid on; xlim([10,fs/2])
title('g'); xlabel('frequency (Hz)'); ylabel('΃p[ (dB)')
ylim([-80,10]);

% G̃XyNg ---------------------------
%      5ڂoăCpXƓ

noise0 = rec(4*NN+1: 5*NN )';    % 5ڂ͎Ĝ
NOISE0 = fft(noise0);                % GDFT
IMPN0 = NOISE0.* ISS;              % ttB^Z
impn = real(ifft(IMPN0));            % tDFTăCpXɊ܂܂G𓾂
IMPN = fft(impn(ip1:ip9), NN);  
           % CpXƓŐ؂oāA[tāANN_Ŏg߂                                     
IMPNdB = 20*log10(abs(IMPN/max(abs(IMP))));   % CpXƓKĂBl߂

hold on; plot( (0:round(NN/2))*(fs/NN), IMPNdB(1:round(NN/2)+1) , 'm')  % gɊ܂܂G̏㏑

legend('g','gɊ܂܂Gx')

return

