
% IR_mes_21_beta11.m

%%
% TSP, Log-SS, NW-SS, MN-SS pCpX
%   TSP, Log-SS ́ACӃXyNg SS݌v@ɂ 


% beta10_1: ؂o600msA2^18

% beta10_2: SSsyn01 
%              tunnel

% beta11_1: ^̎GgĐG
%             ̃foOp (step1 )
% beta11_2: ^̎GgĐG
%            beta11_1 ꂢɂ
% beta11_3
%@@@@^GZꍇ̏
%
% beta11_4
%@@@@extract_ir_01.m ̎
% beta11_5
%@@@@IR_mes_11 𔽉f
% beta11_6 2015/8/26
%       bug fix: figure(81);ȍ~ rec0  bgn

%             ʂ beta11

%% ==============================
clear all; close all;
set(0,'DefaultAxesFontSize',10,'DefaultTextFontSize',10,'DefaultUicontrolFontSize',12)

%% ===== p[^ݒ ===========
% --- M̃p[^ -----
fs = 48000;       % TvOg
NN = 2^18;        % MiPj  2^15
NN = 2^16;        % MiPj  2^15
FL = fs * 0.01;   % GXyNgp̃t[ = 10ms \ 100Hz
% FL = fs * 0.05;   % GXyNgp̃t[ = 50ms \ 20Hz
Amp = 0.5;        % MU

% --- XCb` ------------------------
signal_type = 3;  %  1: TSP
                  %  2: Log-SS
                  %  3: NW-SS
                  %  4: MN-SS
audio_in_out =1;  % I[fBIo͊֐ݒ
                  % @1: wavplay  wavrecord gꍇ
                  % @2: ASIO hCogꍇ
                  % @3: V~[V

% --- ߂̐ݒ
JJ = NN/2;        % IȐM
SL = FL/2;        % Vtg
% --- ̑
kk = 1:NN/2+1;    % iCLXgg܂ł̗Ug
tt = (0:NN-1)/fs;  %Ԏp̕ϐ

%% ===== GXyNg PN ̐ =====
% 茋ʂɊ܂܂G\邽߂ɁATSPALog-SS ̏ꍇ肵Ă܂B

figure(101);
    text(0.05,0.8,' wiG蒆 ','FontSize',16)
    text(0.05,0.7,'@2bԁA𗧂ĂȂ悤ɂĂ','FontSize',16); drawnow;
    drawnow;

switch audio_in_out
    case 1  % wavplay  wavrecord g
        bgn0 = wavrecord(fs*2, fs);  % ^
    case 2  % ASIO g
        bgn0 = pa_wavrecord( 1, 1, fs*2, fs,  [], 'asio' );
    case 3  % V~[V
%         bgn0 = wavread('tunnel');
        load('MN_G_O_UA101_10b');
        bgn0 = nn*100;
    otherwise
        disp('! audio_in_out p[^G['); return
end

figure(101); text(0.05,0.6,' @GI@ ','FontSize',16); drawnow;

bgn = bgn0;

% --- ^f[^̐퐫`FbNiA0if[^j܂܂ĂȂHj
%     NbsOo

% [loss_yn, idx] = chk_dataloss_01(bgn, 10);
[loss_yn, idx] = chk_dataloss_01(bgn(fs*0.1+1:end), 10); % gpAD͐擪0f[^̂
if loss_yn==1; 
    disp(['^f[^ُ at ', num2str(idx+fs*0.1)]), 
    figure(81); plot((idx+fs*0.1-200:idx+fs*0.1+200),bgn0(idx+fs*0.1-200:idx+fs*0.1+200)); return; 
end

% --- 摛
load 'HPF70_30Hz_48k_80';     % gJbgp̍ʉ߃tB^
                              % svȂRgAEg
                              % FIRŁAtB^ẂAϐuHPF70_48kv
bgn = conv(bgn, HPF70_48k);     % tB^s
bgn = bgn(length(HPF70_48k)/2+1:end-length(HPF70_48k)/2+1);
                              % Ԏ␳

% ---  σXyNg --------------------------
PN = mps21(bgn(fs+1:2*fs), FL, SL, NN)';
                                % 1b̎GAσp[XyNg̎Zo
figure(1);
LPN = length(PN);
ff = (0:LPN/2)*fs/LPN;
semilogx(ff,10*log10(PN(1:LPN/2+1)));
hold on; grid on; xlabel('g (Hz)'); ylabel('p[ (dB)');
xlim([30,fs/2]); title('G̃p[XyNg'); drawnow;

%% == M̍ ip[XyNgˌQxˈʑ̌vZ  UAg`j==

% --- M̃p[XyNg
switch signal_type
    case 1; SType=' TSP ';   PS = ones(1,length(kk));
    case 2; SType='LogSS';   PS = 1./kk; 
    case 3; SType='NW-SS';   PS = PN(kk);
    case 4; SType='MN-SS';   PS = sqrt(PN(kk)); 
end

% ff1 = (0:NN/2)/NN*fs;    
% figure(21); subplot(311); plot(ff1, PS); 
% title('M̃p[XyNg'); grid on; hold on;

% --- SSM̍
k1 =0;     % k1: Qx D(k1)=0
k2=NN/2;   % k2: Qx D(k2)=JJ

ss = SSsyn01(PS, k1, k2, NN, JJ, Amp);

figure(22);
subplot(211);
plot(tt,ss); 
title(SType);
grid; xlabel(' (s)'); ylabel('ΐU');
subplot(212);
specgram(ss, [], fs);
xlabel (' (s)'); ylabel ('g (Hz)'); zlabel ('dB')
% caxis([-50 20]); 
colorbar

%% =M̍ĐƘ^i܂͂̃V~[VjƃCpX̌vZ =

% ----- ĐM̃ZbgƁAñCpX

% play_ss = [ss, ss, ss];  % DA  AD ̓ĂꍇA܂́A
                           % 茋ʂAu̒xv̏ꍇ́AQŗǂ
play_ss = [ss, ss];   % 

% --- [ɁAオA̕sA}XΑ ł͂Ȃ
% --- [ɁAオ̕sA}XΑ
nww = fs/1000*10;       % M[XΑ 10ms
ww = hanning(nww)';       % XΑ
play_ss(1:nww/2) = play_ss(1:nww/2) .* ww(1:nww/2);
% play_ss(end-nww/2+1:end) = play_ss(end-nww/2+1:end) .* ww(end-nww/2+1:end);

%-----------------CpX̑--------------------
figure(101);
    text(0.05,0.4,' ăCpXs܂@ ','FontSize',16); drawnow;
    text(0.05,0.3,['@@@',num2str(ceil(length(play_ss)/fs)),'bԁA𗧂ĂȂ悤ɂĂ'],'FontSize',16); drawnow;

switch audio_in_out
    case 1  % wavplay  wavrecord g
        wavplay(play_ss,fs,'async'); % Đ
        rec0 = wavrecord(length(play_ss),fs);  % ^
    case 2  % ASIO g
        rec0 = pa_wavplayrecord( play_ss', [], fs, length(play_ss), 1, 1, [], 'asio' );
    case 3  % V~[V
        imp = wavread('imp11');
        rec0 = conv(play_ss, imp)';
        rec0 = rec0 + bgn0(1:length(rec0));
    otherwise
        disp('! audio_in_out p[^G['); return
end

figure(101); text(0.05,0.2,' CpXI@ ','FontSize',16); drawnow;

% --- ^f[^̐퐫`FbNiA0if[^j܂܂ĂȂHj
%     NbsOo

% [loss_yn, idx] = chk_dataloss_01(rec0, 10);
[loss_yn, idx] = chk_dataloss_01(bgn(fs*0.1+1:end), 10); % gpAD͐擪0f[^̂
if loss_yn==1; 
    disp(['^f[^ُ at ', num2str(idx+fs*0.1)]), 
    figure(81); plot((idx+fs*0.1-200:idx+fs*0.1+200),rec0(idx+fs*0.1-200:idx+fs*0.1+200)); return; 
end

% --- 摛
load 'HPF70_30Hz_48k_80';     % gJbgp̍ʉ߃tB^
                              % svȂRgAEg
                              % FIRŁAtB^ẂAϐuHPF70_48kv
rec0 = conv(rec0, HPF70_48k);     % tB^s
rec = rec0(length(HPF70_48k)/2+1:end-length(HPF70_48k)/2+1);
                              % Ԏ␳
 
%% ----------------------------------------------
% ^Mg`ƃXyNgO \ 
%    iߑEߏĐƓ̓{[AGA`덷Ȃǂ̃`FbNj
% ----------------------------------------------

figure(2)
plot( (1:length(rec))/fs ,rec)
title('^g`iNbsONĂȂH ǍDSN䂪mۂĂ邩Hj'); 
xlabel(' (s)'); ylabel('ΐU'); xlim([0,length(rec)/fs]);
hold on;for ii =1:2;plot([ii*NN,ii*NN]/fs,[-1,1],'g--');end

figure(3)
[bb2,ff,tt1] = specgram(rec,[],fs);
max2 = max(max(20*log10(abs(bb2))));
imagesc(tt1,ff/1000,20*log10(abs(bb2)),[max2-100, max2]);
colorbar;axis xy;grid on
title('^g`̃XyNgOigЂُ݂G`FbNj'); 
xlabel(' (s)'); ylabel('g (kHz)')
             % x (Ⴆ΁Aől -80dB x )̘c͖Ăǂƍl

figure(4)
[bb2,ff,tt1] = specgram(rec(NN+1:2*NN),256,fs);
max2 = max(max(20*log10(abs(bb2))));
imagesc(tt1,ff/1000,20*log10(abs(bb2)),[max2-100, max2]);
colorbar;axis xy;grid on
title('^g`̃XyNgOi1j'); xlabel(' (s)'); ylabel('g (kHz)')

% --- 2ڐ؂o

rec2 = cross_fade_01(rec, NN)';  % NXtF[h^2ڐ؂o

figure(31);
plot(tt,rec2); grid on; title('M̉');

figure(32);
specgram(rec2,512,fs);
% caxis([-80 10]);
colorbar; title('M̃XyNgO')

%%---- SS̋tM|IR𓾂-----------------

REC = fft(rec2);%Z邽߂Ɍn̉XyNg
IR = REC./ fft(ss);
ir = real(ifft(IR));

figure(41)
plot(tt,ir); title('CpX')
xlabel('Time'); ylabel('Amplitude'); grid on;
figure(42)
specgram(ir, 512, fs); caxis([-110 -20]); colorbar;
title('CpX'); xlabel(''); ylabel('g')

%%---- ir ɏd􂵂ĂG -----------------
% --- GZꍇ iNN > length(bgn)=2*fsjG̃[vڑs
Lw = 509;                  % cross-fade i̔{j 
                           % 4̔{+1 % 48kHz TvOŖ10ms
ww = hanning(Lw);          % ֐ȋłj
Lw2 = (Lw-1)/2;            % half-window 

bgn9 = bgn;                % ꎞϐ
bgn9(1:Lw2) = bgn(1:Lw2).*ww(1:Lw2) + ...
    bgn(end-Lw2+1:end).*ww(end-Lw2+1:end);  % [E[ƃNXtF[h
bgn9 = bgn9(1:end-Lw2);    % Ō̓NXtF[hőOɂ̂ŕsv

Nrep = ceil(2*NN / length(bgn9)) -1; % ^MƓɂ邽߂̐ڑ
bgn99 = bgn9;
for ii =1:Nrep; bgn99 = [bgn99; bgn9]; end % bgn9̐ڑ

% --- ǦvZ
bgn999 = cross_fade_01(bgn99, NN)';  % NXtF[h^2ڐ؂o
BGN = fft(bgn999);
BGN = BGN./ fft(ss);
bgn_ir = real(ifft(BGN));

npowerdB = 10*log10(mean(bgn_ir.^2));
disp([SType, ': Gx = ',num2str(npowerdB,'%6.1f'), 'dB'])

% ==============================================================

%----CpXg𓾂-------------------------
% --- v؂o
% icut1 = round(20/1000*fs);      % őlO 20ms ؂oibj
% icut2 = round(600/1000*fs);     % ől 600ms ܂Ő؂oibj
% [amax, idx] = max(ir);          % őlʒǔo
% ir3 = [ir, ir, ir]; 
% ir_main = ir3(NN+idx-icut1+1: NN+idx+icut2); % ؂o(+1͐M)

[ir_main, idx1] = extract_ir_01(ir, fs);

tt_main = (idx1: idx1+length(ir_main)-1)/fs;       % Ԏpϐ

figure(43)
plot(tt_main,ir_main); title('ṽCpX')
xlabel('Time'); ylabel('Amplitude'); grid on;
figure(44)
specgram(ir_main, 64, fs); caxis([-110 -20]); colorbar;
title('ṽCpX'); xlabel(' (s)'); ylabel('g (Hz)')

% --- g
HH1 = fft(ir_main,length(ir_main)*4);              
HH2 = abs(HH1).^2;

%----GσXyNg-------------------------

PNS = mps21(bgn_ir, 2^11, 2^11/2,2^13*8); %g\߂ꍇ
PNS = PNS * length(ir_main);   % IR̒ɂGxɒ

%---gpn̎g---------------------

figure(5)
% n̎gi茋ʁj
ffHH2 = (0:length(HH2)/2)*fs/length(HH2);
semilogx(ffHH2,10*log10(HH2(1:length(HH2)/2+1)));
hold on; grid on;
%G
ffN = (0:length(PNS)/2)*fs/length(PNS);
semilogx(ffN, 10*log10(PNS(1:length(PNS)/2+1)),'r');
title('茋 (G͕Ă̂ŎG12dBxႭ\)');
xlabel('g (Hz)'); ylabel('΃p[(dB)');
legend('茋','G',  4);
xlim([30 25000]);

%% =肵f[^̕ۑ
% save 'PN_MN' PN;
% save 'ir_MN' ir;
% save 'ir_main_MN' ir_main;
save 'ir_main_00' ir_main;

return
