
function ss = SSsyn01(PS, k1, k2, NN, JJ, Amp)

%% SSM(|g)
%
% PS: p[XyNg
% k1: Qx D(k1)=0
% k2: Qx D(k2)=JJ
% NN: M
% JJ: 
% Amp: gU

%%
% --- Qx

gd = cumsum(PS);                      % ϕ

C1 = sum(PS(1:k1+1));                 % Qx D(k1)=0 Ƃ邽
C2 = JJ/sum(PS(k1+2:k2+1));           % Qx D(k2)=JJ Ƃ邽

gd = C2 * (gd - C1);

% --- ʑ
ph = 2*pi/NN * (cumsum(gd) - gd(1));  % k=0  ph(k)=0
ph = ph * ( round( ph(NN/2+1)/pi)* pi/ph(NN/2+1));
                                      % k=NN/2  ph(k)=m

% --- U
Den = sum(PS);                               % M̃GlM[
AM = Amp*sqrt(JJ)*sqrt(PS)*sqrt((NN/2)/Den)/sqrt(2); % UvZ

% --- M
SS(1:NN/2+1) = AM.*exp(-j*ph);               % MXyNg
SS( NN/2+2 : NN) = conj(fliplr(SS(2:NN/2))); % ܂Ԃ
ss =real(ifft(SS));                          % ԐMɕϊ

ss=[ss((NN+JJ)/2+1:NN), ss(1:(NN+JJ)/2)];    % ~Vtg

return

