
%  wWx`}[N@ A-11

clear all; close all;

f_oct = 125*2.^(0:5);

% --- IR ̓ǂݍ

% [ir,fs] = wavread('a11');
% plot(ir);

fs = 48000;
% fid=fopen('a11.fb','r');
% ir=fread(fid,'float32');
% fclose(fid);

load ir_main_00
ir = ir_main;

% ir = zeros(1,length(ir));@% IN^[uohtB^`FbNp
% ir(1)=1;

LL = length(ir);
if(size(ir,1) > size(ir,2)); ir = ir.'; end  % xNg

ir2 = ir.^2;
tt = (0:LL-1)/fs;

figure(11); plot(tt, ir); grid on
title('IR'); xlabel('Time (s)')

figure(12); plot(tt, 10*log10(ir2)); grid on
title('IR^2'); ylabel('IR^2 '); xlabel('Time (s)')
ylim([-100,100]);

% --- ш敪

load octbandfilter

filtered_ir = zeros(6,length(ir));

for ii = 1:6
    filtered_ir(ii,:) = filter(octband_filter(ii+2),ir);
end

% --- cȐ

rr = zeros(size(filtered_ir));
for ii = 1:6
    rr(ii,:) = fliplr(cumsum(fliplr(filtered_ir(ii,:).^2)));
    rr(ii,:) = rr(ii,:)/rr(ii,1);
end

rrdB = 10*log10(rr);

% --- [ c RT ] ----------------------------

for ii = 1:6
    % cȐ\
    figure(20+ii)
    plot(tt, rrdB(ii,:))
    grid on;hold on;ylim([-100,10]);
    title([num2str(f_oct(ii)),' Hz band'])
    
    % 5dB & 35dB NX_
    rr5 = rrdB(ii,:)+5; rr5(rr5<0)=0;
    [amin5,idx5] = min(rr5);
    rr35 = rrdB(ii,:)+35; rr35(rr35<0)=0;
    [amin35,idx35] = min(rr35);
    
    % 5-35dB ŏ撼
    PP = polyfit((idx5-1:idx35-1)/fs,rrdB(ii,idx5:idx35),1);
    YY = polyval(PP,(idx5-1:idx35-1)/fs);
    plot((idx5-1:idx35-1)/fs,YY,'g','LineWidth',4)

    % c
    RT(ii) = -60/PP(1);
end

% --- ʂ̕\
figure(29)
loglog(f_oct, RT,'-o');
ylim([0.1,5]);xlim([64,8000]);grid on
title('c T30');
ylabel('Reverberation Time (s)');
xlabel('Octave Band Center Frequency (Hz)')

RT = round(RT *100)/100;
disp('[ c RT ]')
for ii=1:6
    disp(num2str([f_oct(ii),RT(ii)]))
end

% --- [ EDT ] ---------------------------------

for ii = 1:6
    
%         % cȐ\
%     figure(50+ii)
%     plot(tt, rrdB(ii,:))
%     grid on;hold on;ylim([-100,10]);
    
    % 0.1dB & 10dB NX_
    rr01 = rrdB(ii,:)+0.1; rr01(rr01<0)=0;
    [amin01,idx01] = min(rr01);
    rr10 = rrdB(ii,:)+10; rr10(rr10<0)=0;
    [amin10,idx10] = min(rr10);
    
    % 0.1 - 10dB ŏ撼
    PP = polyfit((idx01-1:idx10-1)/fs,rrdB(ii,idx01:idx10),1);

    % EDT
    EDT(ii) = -60/PP(1);
   
end

% ʂ̕\
figure(39)
loglog(f_oct, EDT, '-o');
ylim([0.1,5]);xlim([64,8000]);grid on
title(' EDT');
ylabel('Early Decay Time (s)');
xlabel('Octave Band Center Frequency (Hz)')

EDT = round(EDT *100)/100;
disp('[ EDT ]')
for ii=1:6
    disp(num2str([f_oct(ii),EDT(ii)]))
end

% --- [ C80 ] -------------------------------


idx80ms = 0.08*fs+1;

filtered_ir2 = filtered_ir.^2;
for ii = 1:6
    % IR X^[gn_
    [amax,idxmax] = max(filtered_ir2(ii,:));
    ir2_20 = filtered_ir2(ii,:)/amax*100;
    ir2_20_0=ir2_20; ir2_20(ir2_20>1)=1;
    [amax20,ir0(ii)] = max(ir2_20);  % ir0 ɑш悲Ƃ̊Jn_
    
%     figure(60+ii);plot(10*log10(ir2_20_0));hold on
%     plot([ir0(ii),ir0(ii)],[-100,100],'r')

    % C80 vZ
    C80(ii) = sum(filtered_ir2(ii,ir0(ii):idx80ms+ir0(ii)))/...
        sum(filtered_ir2(ii,idx80ms+ir0(ii)+1:end));
    
end

C80 = 10*log10(C80);

% ʂ̕\
figure(49)
semilogx(f_oct, C80, '-o');
ylim([0,20]);xlim([64,8000]);grid on;hold on
title('C80');
ylabel('C80 (dB)');
xlabel('Octave Band Center Frequency (Hz)')

C80 = round(C80 *100)/100;
disp('[ C80 ]')
for ii=1:6
    disp(num2str([f_oct(ii),C80(ii)]))
end

% cȐ߂Ă݂
for ii=1:6
    C80rr(ii) = (1-rr(ii,ir0(ii)+idx80ms))/rr(ii,ir0(ii)+idx80ms);
end
C80rrdB = 10*log10(C80rr);
% figure(88)
semilogx(f_oct, C80rrdB, '-or');


% Jn_
[amax,idxmax] = max(ir2);
ir2_20 = ir2/amax*100;
ir2_20(ir2_20>1)=1;
[amax20,ir0] = max(ir2_20);  % ir0 ̊Jn_
ir0

figure(81)
plot(10*log10(ir2));grid on;hold on;
plot([ir0,ir0],[-10,100],'r')

ir_1 = ir(ir0:ir0+idx80ms-1);
ir_2 = ir(ir0+idx80ms:end);
ir_1 = [ir_1, zeros(1,LL-length(ir_1))];
ir_2 = [ir_2, zeros(1,LL-length(ir_2))];


ww1 = zeros(1,LL);ww1(ir0:ir0+idx80ms-1)=1;
ir_1 = ir.*ww1;
ww2 = zeros(1,LL);ww2(ir0+idx80ms:end)=1;
ir_2 = ir.*ww2;

tt = (1:LL)/fs;
figure(82);plot(tt,ir_1);hold on
plot(tt,ir_2,'r'); grid on


% --- ш敪
filtered_ir_1 = zeros(6,length(ir_1));
for ii = 1:6
    filtered_ir_1(ii,:) = filter(octband_filter(ii+2),ir_1);
end

filtered_ir_2 = zeros(6,length(ir_2));
for ii = 1:6
    filtered_ir_2(ii,:) = filter(octband_filter(ii+2),ir_2);
end

figure(83);
plot(tt,filtered_ir_1(1,:));hold on;
plot(tt,filtered_ir_2(1,:),'r'); grid on



for ii = 1:6
    % C80 vZ
    C80(ii) = sum(filtered_ir_1(ii,:).^2)/sum(filtered_ir_2(ii,:).^2);
end

C80 = 10*log10(C80);

% ʂ̕\
figure(491)
semilogx(f_oct, C80, '-o');
ylim([0,20]);xlim([64,8000]);grid on;hold on
title('C80');
ylabel('C80 (dB)');
xlabel('Octave Band Center Frequency (Hz)')

C80 = round(C80 *100)/100;
disp('[ C80 ]')
for ii=1:6
    disp(num2str([f_oct(ii),C80(ii)]))
end



% --- [ ԏdS Ts ] -------------------------------

idx80ms = 0.08*fs+1;

filtered_ir2 = filtered_ir.^2;
for ii = 1:6
    % IR X^[gn_
    [amax,idxmax] = max(filtered_ir2(ii,:));
    ir2_20 = filtered_ir2(ii,:)/amax*100;
    ir2_20_0=ir2_20; ir2_20(ir2_20>1)=1;
    [amax20,ir0(ii)] = max(ir2_20);  % ir0 ɑш悲Ƃ̊Jn_
    
%     figure(60+ii);plot(10*log10(ir2_20_0));hold on
%     plot([ir0(ii),ir0(ii)],[-100,100],'r')

    % Ts vZ
    tttt = (0:LL-ir0(ii))/fs;
    Ts(ii) = sum(filtered_ir2(ii,ir0(ii):end).*tttt)/...
        sum(filtered_ir2(ii,ir0(ii):end));
    
end

% ʂ̕\
figure(59)
semilogx(f_oct, Ts, '-o');
ylim([0,1]);xlim([64,8000]);grid on;hold on
title('ԏdS Ts');
ylabel('Center Time (s)');
xlabel('Octave Band Center Frequency (Hz)')

Ts = round(Ts *1000)/1000;
disp('[ ԏdS Ts ]')
for ii=1:6
    disp(num2str([f_oct(ii),Ts(ii)]))
end



return   

