
clear all; close all;

% [ir,fs] = wavread('a11');
% plot(ir);

fs = 48000;
fid=fopen('a11.fb','r');
ir=fread(fid,'float32');
fclose(fid);
figure(2)
plot(ir)

ir = zeros(1,length(ir));
ir(1)=1;

load octbandfilter

if(size(ir,1) > size(ir,2))
    ir = ir.';
end

filtered_sig = zeros(10,length(ir));

for ii = 1:10
    filtered_sig(ii,:) = filter(octband_filter(ii),ir);
end

LL=length(ir);
ff = (0:LL-1)/LL*fs

figure(11)
for ii = 1:10
% for ii = 1:9
    FIL_IR = fft(filtered_sig(ii,:));
    FIL_IR = abs(FIL_IR).^2;
    semilogx(ff(1:end/2),10*log10(FIL_IR(1:end/2)));
    grid on;hold on
end

