
%% Mn M

function [mm, IMM] = sig_gen_MLS_01(NN, AA)

%%
% 
% NN: MF 2ׂ̂ŗ^@Mn NN-1 ̒ɂȂ
% AA: U     (AA0.4) Ԍ̍őlPȉɂɂ́Â炢K
% o
% mm:  NN-1 Mn
% IMM: MnDFTttB^ ( NN-1)

% CpX́ANN ȉł邱ƂKv

% Ver. 1.0;   2013.8.28 TDU Y. Kaneda
% Ver. 1.1;   2014.8.16 TDU Y. Kaneda
%               IMM ̃oOC (sig_gen_MLS_01_1  )

% ̃vO͎QlvOł̂ŁApɂĂ
% ̐ӔCœmFsĂB
% s܂A
% kaneda@c.dendai.ac.jp
% ܂ł񂢂ƍKłB

%%

if AA >= 0.4; AA = 0.4; end

Lg = round(log(NN)/log(2));  % n̒iNN2̉悩vZj

switch Lg  % n
    case 3; g = [1,1,0];    % a0, a1, a2
    case 4; g = [1,1,0,0];
    case 5; g = [1,0,1,0,0];
    case 6; g = [1,1,0,0,0,0];
    case 7; g = [1,1,0,0,0,0,0];
    case 8; g = [1,0,1,1,1,0,0,0];
    case 9; g = [1,0,0,0,1,0,0,0,0];
    case 10; g = [1,0,0,1,0,0,0,0,0,0];
    case 11; g = [1,0,1,0,0,0,0,0,0,0,0];
    case 12; g = [1,1,0,0,1,0,1,0,0,0,0,0];
    case 13; g = [1,1,0,1,1,0,0,0,0,0,0,0,0];
    case 14; g = [1,1,0,1,0,1,0,0,0,0,0,0,0,0];
    case 15; g = [1,1,0,0,0,0,0,0,0,0,0,0,0,0,0];
    case 16; g = [1,1,0,1,0,0,0,0,0,0,0,0,1,0,0,0];
    case 17; g = [1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0];
end

T = 2^Lg-1;       % Mn()
mm = zeros(1,T);  % Mni[p
mm(1:Lg) = 1;     % lݒ(ŏ̌n܂ł͑S1)

%% --- Mn񐶐

for k = (Lg+1):T; % l+1̃CfbNX琶Jn
    mm(k) = mod( sum( mm(k-Lg:k-1).* g), 2);
end

mm = 1 - 2*mm;    % -11MnM
mm = AA * mm;     % U AA Ƃ

%%

MM = fft(mm);                         % Mn DFT XyNg
IMM = conj(MM);                       % ʑ̋tiԎ̍E]j
IMM = IMM /  (mean(abs(MM(2:T))))^2;  % Űt 
    %i  MM  2:T ̐UƏZĂPɂȂ悤Ɂj

return

%--------------------------------------------------------------------------